#!/usr/bin/env python
# -*- coding: utf-8 -*-
import random
from . import config


def get_uuid():
    s = []
    hexDigits = "0123456789abcdef"
    for i in range(36):
        s.append(hexDigits[random.randint(0, 15)])
    s[14] = "4"
    s[19] = hexDigits[(int(s[19], 16) & 0x3) | 0x8]
    s[8] = s[13] = s[18] = s[23] = "-"
    return "".join(s)


def check_param(params, property):
    if property not in params or params[property] == "":
        return None
    return params[property]


def getRequestPath(functionId):
    return "/{0}/functions/{1}".format(config.DEFAULT_API_VERSION, functionId)


def getTaskRequestPath(functionId):
    return "{0}/task".format(getRequestPath(functionId))


def buildArnString(region, accountId, serviceName, functionName):
    return "acs:fc:" + region + ":" + accountId + ":service:" + serviceName + ":function:" + functionName
